% Kostis Hatzitaskos
% Ruud MLE
% June 24 2003

function [like]=MLE(prm);

% Load data ---------------------------------------------------------------
load stat;
load data;

% Initialize variables ----------------------------------------------------
z=size(X,2);                    % Number of explanatory variables
lik=zeros(S,Y);

% Likelihood --------------------------------------------------------------

% For each school and each ranking, calculates the probabilities that the
% jth ranked journal is better than the ones ranked below it, adds up
% across rankings, weighs for simulation, then takes logs and adds across
% schools to find likelihood.

for y=1:Y;
    % Year loop
    numcho=matcho(:,:,y);
    meanuy=log(X(J*(y-1)+1:J*y,:)+eps)*prm(1:z)';
    hold=hldn(:,:,y);
    for s=1:S;
        % School loop
        hldpS=hldp(:,s,y);
      %  exb=exp(meanuy+log(hldpS+eps)*prm(z+1)); % Add value of owned last period

	% removed the log of the hldpS (past holdings) variable  8/17/04
	exb=exp(meanuy);

        if numcho(s)==J | numcho(s)==0;
            lik(s,y)=1;
            continue;
            % If no choice or all choice, nothing to explain, it's a
            % question of the school's budget
        end;
        Bexb=sum(exb.*(1-hold(:,s)));   % Sum of mean utility of nonchosen
        Rlod=['load Rs',int2str(s),'y',int2str(y)];
        eval(Rlod);
        probs=zeros(1,size(R,2));
        
        % probs stores the probability of each ranking
        % probr stores the probability of a journal within a ranking
        
        for r=1:size(R,2);
            probr=zeros(1,numcho(s));
            % Ranking loop
            rkg=R(:,r);
            probr(1)=exb(rkg(1))/sum(exb);
            for j=2:numcho(s);
                % Journal loop
                set=rkg(j:numcho(s));
                sumexb=sum(exb(set))+Bexb;
                probr(j)=exb(rkg(j))/sumexb;
                if probr(j)<0;
                    keyboard;
                end;
            end;
            probs(r)=prod(probr);
        end;
        % Reweigh for simulation, store as probability
        lik(s,y)=sum(probs)*(factorial(numcho(s))/size(R,2));
        if lik(s,y)==0;
            lik(s,y)=eps;
        end;
        if lik(s,y)<0;
            keyboard;
            lik(s,y)=eps;
        end;
        if lik(s,y)>1;
            %keyboard;
	    %fprintf('keyboard');
	    fprintf('Value over One: %5.5f        Numcho: %5.5f', lik(s,y), numcho(s));
	    fprintf('\n');
            lik(s,y)=1;
        end;
    end;
end;

like=-sum(sum(log(lik)));