% Kostis Hatzitaskos
% Mellon journal estimation --- Ruud proposal
% June 24 2003

% Initialization ----------------------------------------------------------
clc;
clear;
clear global;
pack;
delete('log_ruud.txt');
diary('log_ruud.txt');
profile off;
profile on;
mtime=cputime;                  % Start Timing
rand('state',sum(100*clock));   % Randomize rand

fprintf('\n');
fprintf('------------- Journal Choice Estimation - Ruud -------------');
fprintf('\n\n');

% Load data ---------------------------------------------------------------
load stat;
load data;
load ranks;
% Contains S, J, Y
% S: number of libraries (schools)
% J: number of journals
% Y: number of years

% Estimate ----------------------------------------------------------------
fprintf('\n');
fprintf('Starting Ruud-MLE with data for\n');
fprintf('%.0f Schools, %.0f Journals, %.0f Years\n',S,J,Y);
fprintf('%.0f Maximum Rankings',M);
fprintf('\n\n');

prm=[0 0];                    % Initial values
% prm=[-0.0020478 0.0021064 0.000317 0];
ini=prm;

options=optimset('Display','iter','MaxFunEvals',5000,'MaxIter',2000,...
    'TolX',1e-5,'LevenbergMarquardt','on','GradObj','off');
% [prm,der,fval]=fminunc(@MLE,prm,options);
[prm,der,fval]=fminsearch(@MLE,prm,options);

fprintf('        |            Price               \n');
fprintf('Initial |     %12.5g        \n',ini(1));
fprintf('MLE     |     %12.5g        \n',prm(1));
fprintf('        |            Citations           \n');
fprintf('Initial |     %12.5g        \n',ini(2));
fprintf('MLE     |     %12.5g        \n',prm(2));

save prm_est.mat prm ini;

% Output Time -------------------------------------------------------------
fprintf('\n');
mtime=cputime-mtime;
mtimem=fix(mtime/60);
mtimes=rem(mtime,60);
mtimeh=fix(mtimem/60);
mtimem=rem(mtimem,60);
fprintf('------------------------------------------------------\n');
fprintf('.m file execution time %.0fhrs, %.0fmin, %2.1fsec\n',mtimeh,mtimem,mtimes);
fprintf('------------------------------------------------------\n');

beep;
diary off;

% Output Profiler ---------------------------------------------------------
% profile report log_prf;
profile off;